Attribute VB_Name = "Stuff"

Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Const SW_NORMAL = 1

Public Type TransferProperties
TransferRate As Single
BeginTransfer As Single
BytesRemaining As Single
BytesAlreadySent As Single
FilePathName As String
Filename As String
Url As String
SvrUrl As String
Resume As Boolean
FileLength As Single
Server As String
ShowStatus As Boolean
End Type

Global Sec As Single
Global Min As Single
Global Hr As Single
Global Transfer As TransferProperties
Public Function ParseHeader(DATA As Variant, ToRetrieve As String)
On Error Resume Next
If DATA = "" Then Exit Function
Dim EndBYTES%, A$, LENGTHEND%, PART%, Part2%, RetrieveLength%
If InStr(DATA, ToRetrieve) > 0 Then
LENGTHEND = Len(DATA)
PART = InStr(DATA, ToRetrieve)
RetrieveLength = Len(ToRetrieve)
A = Right(DATA, LENGTHEND - PART - RetrieveLength)
LENGTHEND = Len(A)
If InStr(A, vbCrLf) > 0 Then
Part2 = InStr(A, vbCrLf)
A = Left(A, Part2 - 1)
End If
ParseHeader = A
End If
End Function

Public Function FileCheck(Path$) As Boolean
On Error Resume Next
'USAGE: If FileCheck("C:\windows\kewl.exe") then msgbox "it was found"
FileCheck = True 'Assume Success
On Error Resume Next
Dim Disregard As Long
Disregard = FileLen(Path)
If Err <> 0 Then FileCheck = False
End Function

Public Function ByteConversion(NumberOfBytes As Single) As String
On Error Resume Next
If NumberOfBytes < 1024 Then  'checks to see if its so small that it cant be converted into larger grouping
ByteConversion = NumberOfBytes & " Bytes"
End If
If NumberOfBytes > 1024 Then  'Checks to see if file is big enough to convert into KB
ByteConversion = Format(NumberOfBytes / 1024, "0.00") & " Kb"
End If
If NumberOfBytes > 1024000 Then 'Checks to see if its big enough to convert into MB
ByteConversion = Format(NumberOfBytes / 1048576, "###,###,##0.00") & " Mb"
End If
End Function

Function ConvertTime(TheTime As Single) As String
On Error Resume Next
Dim NewTime As String
Dim Sec As Single
Dim Min As Single
Dim H As Single
If TheTime > 60 Then
Sec = TheTime
Min = Sec / 60
Min = Int(Min)
Sec = Sec - Min * 60
H = Int(Min / 60)
Min = Min - H * 60
NewTime = H & ":" & Min & ":" & Sec
If H < 0 Then H = 0
If Min < 0 Then Min = 0
If Sec < 0 Then Sec = 0
Sec = Format(Sec, "00")
Min = Format(Min, "00")
H = Format(H, "00")

If H = 0 Then
NewTime = Min & " Minute(s) " & Sec & " Second(s)"
Else
NewTime = H & " Hour(s) " & Min & " Minute(s) " & Sec & " Second(s)"
End If

ConvertTime = NewTime
End If

If TheTime < 60 Then
NewTime = TheTime & " Second(s)"
ConvertTime = NewTime
End If
End Function
Public Function ParseUrl(strURL As String)
On Error Resume Next
If strURL = "" Then Exit Function
Dim Pos%, Length%, NextPos%, LENGTH2%, POS2%, POS3%, strType$
    Pos = InStr(strURL, "://") 'Record position of ://
    LENGTH2 = Len("://") 'Record the length of it
    Length = Len(strURL) 'Length of the entire url
        If InStr(strURL, "://") Then  ' check if they entered the http:// or ftp://
        strType = Left(strURL, InStr(strURL, "://") - 1)
         If LCase(strType) = "http" Then
                
                 strURL = Right(strURL, Length - LENGTH2 - Pos + 1)
                 Length = Len(strURL)
                 
                      
                'I hate parsing strings.. Dont you???? SOOOO BORRRRINGGGGGG!%!%!
         End If
        
        End If
            If InStr(strURL, "/") Then 'looks for the first / mark going from left to right
            POS2 = InStr(strURL, "/") 'gets the position of the / mark
            Dim StrFile$: StrFile = strURL 'load the variables into each other
            Do  'Do the loop until all is left is the filename
            LENGTH2 = Len(StrFile) 'get the length of the filename every time its passed over by the loop
            POS3 = InStr(StrFile, "/") 'find the / mark
            StrFile = Right(strURL, LENGTH2 - POS3) 'slash it down removing everything before the / mark including the / mark...
            Loop Until InStr(StrFile, "/") = 0
            
            Transfer.Filename = StrFile
            
            Transfer.Server = Left(strURL, POS2 - 1) 'removes everything after the / mark leaving just the server name as the end result
            End If

End Function
Public Sub CloseSocket(Winsock As Winsock)
On Error Resume Next
Do Until Winsock.State = 0
Winsock.Close
Winsock.LocalPort = 0
Close #1
Loop
End Sub

Public Sub ResetVariables()
On Error Resume Next
Transfer.BeginTransfer = 0
Transfer.BytesAlreadySent = 1
Transfer.BytesRemaining = 0
Transfer.FileLength = 0
Transfer.Filename = ""
Transfer.FilePathName = ""
Transfer.Resume = False
Transfer.Server = ""
Transfer.SvrUrl = ""
Transfer.TransferRate = 0
Transfer.Url = ""
Transfer.ShowStatus = True
Min = 0
Sec = o
Hr = 0

End Sub

Public Function UpdateProgress(pb As Control, ByVal Percent As Integer)
On Error Resume Next
'Replacement for progress bar..looks nicer also
Dim Num$ 'use percent
If Not pb.AutoRedraw Then 'picture in memory ?
pb.AutoRedraw = -1 'no, make one
End If
pb.Cls 'clear picture in memory
pb.ScaleWidth = 100 'new sclaemodus
pb.DrawMode = 10 'not XOR Pen Modus
'Num$ = Format$(Percent, "###0") + "%"
'pb.CurrentX = 50 - pb.TextWidth(Num$) / 2
'pb.CurrentY = (pb.ScaleHeight - pb.TextHeight(Num$)) / 2
'pb.Print Num$ 'print percent
pb.Line (0, 0)-(Percent, pb.ScaleHeight), , BF
pb.Refresh 'show differents
End Function

Public Function Download(Url As String, Path As String, ShowStatus As Boolean)
On Error Resume Next
ParseUrl (Url)
Transfer.Url = Url
Transfer.FilePathName = Path
Main.Winsock.Connect Transfer.Server, 80
Transfer.ShowStatus = ShowStatus
If Transfer.ShowStatus = True Then
Main.Frame1.Visible = True
Main.Frame2.Visible = False
Main.Frame3.Visible = False
End If
End Function
Public Function ShowList()
On Error Resume Next
Dim Ini As New IniFile
Main.lstProgram.Clear
Dim Num%, A%, Name$, Version$, Path$, Dates$
Ini.Path = App.Path & "\programs.ini"

Ini.Section = "Applications"
Ini.Key = "Count"
Num = Ini.Value

For A = 1 To Num
Ini.Key = "Name" & A
Name$ = Ini.Value
Ini.Key = "Version1"
Version$ = Ini.Value
Ini.Key = "Date1" & A
Dates$ = Ini.Value
Main.lstProgram.AddItem Name$
Next A

End Function
Public Function OpenIt(frm As Form, ToOpen As String)
On Error Resume Next
'USAGE: OPENIT "c:\windows\blah.exe"
'USAGE: OPENIT "http://www.coldfusionz.net"
'USAGE: OPENIT "mailto: magadass@usa.net"
ShellExecute frm.hwnd, "Open", ToOpen, &O0, &O0, SW_NORMAL
End Function
